Option Explicit
'these are all general routines for any program
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpAppName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Integer
Declare Function GetModuleUsage% Lib "Kernel" (ByVal hModule%)
'clipboard format constants
Const CF_TEXT = 1, CF_BITMAP = 2, CF_DIB = 8, CF_PALETTE = 9
Global i As Integer
Global IniFile As String
Global ListOfUsers() As String
Global ListOfPassphrases() As String
Global ListOfRecs() As String
Global NumberOfUsers As Integer
Global NumberOfRecs As Integer
Global UserName As String
Global Passphrase As String
Global Recipient As String
Global Filename As String
Global CryptOpt As Integer
Global Wipe As Integer
Global KeepOpen As Integer
Global PGPDir As String
Global PGPPIF As String
Global Arg As String
Global TempFile1 As String
Global TempFile2 As String
Global ClipSign As String
Global AskPassphrase As Integer
Global Strikes As Integer
Global CLIPCRYPT As Integer
Global fha As Integer
Global fhb As Integer
Global toss As Integer
Global Abort As Integer
Global Warning As Integer
Global AddFail As Integer

Sub AddKey ()
Dim ThisFile As String
AddFail = False

If ThisFile$ = "" Then

	frmPGPWinShell.cmdBrowse.Filter = "Key Files (*.asc)|*.asc"
	' Display Save As dialog.
	frmPGPWinShell.cmdBrowse.FilterIndex = 1
	frmPGPWinShell.cmdBrowse.DefaultExt = "ASC"
	
	frmPGPWinShell.cmdBrowse.Action = 1
	' Exit if User cancels the dialog.
	If Err = 32755 Then Exit Sub
	ThisFile = frmPGPWinShell.cmdBrowse.Filename

End If

If ThisFile = "" Then
    AddFail = True
    Exit Sub
End If

ThisFile = Chr$(34) & ThisFile & Chr$(34)
toss% = Shell(PGPDir$ & "PGP1.PIF -ka " & ThisFile$, 3)
While GetModuleUsage(toss%) > 0    ' Has Shelled program finished?
    DoEvents              ' If not, yield to Windows.
Wend

End Sub

Sub AskPassword ()

AskPassphrase = True
For i = 1 To (NumberOfUsers)
	If UserName = ListOfUsers(i) Then
		Passphrase$ = ListOfPassphrases(i)
		AskPassphrase = False
	End If
Next i

Strikes = 0
If AskPassphrase = True Then
DemandPassphrase:
	frmAskPassphrase.Show
End If

Process

End Sub

Sub DeleteKey (ThisUser As String)
If ThisUser$ <> "" Then
ThisUser = Chr$(34) & ThisUser & Chr$(34)
toss% = Shell(PGPDir$ & "PGP1.PIF -kr " & ThisUser$, 3)
While GetModuleUsage(toss%) > 0    ' Has Shelled program finished?
    DoEvents              ' If not, yield to Windows.
Wend
End If

End Sub

Sub ExtractKey (ThisUser As String)
If ThisUser$ <> "" Then
ThisUser = Chr$(34) & ThisUser & Chr$(34)
toss% = Shell(PGPDir$ & "PGP1.PIF -kx " & ThisUser$, 3)
While GetModuleUsage(toss%) > 0    ' Has Shelled program finished?
    DoEvents              ' If not, yield to Windows.
Wend
End If

End Sub

Function FileExists (TestFile As String) As Integer
Dim fhc As Integer

	'Get an unused file handle
	fhc = FreeFile

On Error GoTo Hiccup
	Open TestFile For Input As fhc
	FileExists = True
	'We're done! Close the output file
	Close fhc
	GoTo Existence
Hiccup:
	FileExists = False
	Resume Existence
Existence:
End Function

Function GetINI$ (AppName$, KeyName$, Default$, Filename$)
Dim Size, ValidLength As Integer
Dim ReturnString As String

Size = 255
ReturnString$ = Space$(Size)
ValidLength% = GetPrivateProfileString(AppName$, KeyName$, Default$, ReturnString$, Size, Filename$)
GetINI$ = Left$(ReturnString$, ValidLength%)

End Function

Function GetTempFile1 () As String
Dim ac$                 'Avoid Confusion - used to build a unique filename
Dim acd#                '       and to clean up the final line of code.
Dim TempFile1$

	'Get the TEMP setting
	TempFile1$ = Environ$("TEMP")

	'If it's empty, then default to the root of C:
	If TempFile1$ = "" Then
		TempFile1$ = "C:\"
	Else
		'If TEMP isn't empty, remove any unnecessary spaces and make sure
		'it ends with a backslash.
		TempFile1$ = Trim$(TempFile1$)
		If Right$(TempFile1$, 1) <> "\" Then TempFile1$ = TempFile1$ + "\"
	End If

	'Build a unique file name based on the system time. The integer portion rarely
	'changes so remove it and mutilply the fractional part by 10000 to move it into
	'the integer portion. Convert that to an integer and then convert it to a string
	acd = Now
	acd = (acd - Fix(acd)) * 100000
	ac = LTrim$(CStr(Fix(acd)))

	'Finally, we get to build the filename
	GetTempFile1 = TempFile1$ + "~pr" + ac + ".txt"
End Function

Function GetTempFile2 () As String
	
	TempFile2$ = Left$(TempFile1$, (Len(TempFile1$) - 4))

	'Finally, we get to build the filename
	If CryptOpt = 0 Then
		GetTempFile2 = TempFile2$ + ".asc"
	ElseIf CryptOpt = 1 Then
		GetTempFile2 = TempFile2$ + ".asc"
	ElseIf CryptOpt = 2 Then
		GetTempFile2 = TempFile2$
	End If

End Function

Function INISetup% (Filename$)
Dim Result, FileNum As Integer

'this function checks to see if the ini file exists. if
'not it attempts to create it. returns false if it can't
INISetup% = False
If Dir$(Filename$) = "" Then    'not there then make
    On Error GoTo INIError
    FileNum% = FreeFile
    Open Filename$ For Output As FileNum%
    Close #FileNum%
    frmWait.Show
    SetUpUsers
    SetUpRecs
    Unload frmWait
    On Error GoTo 0
Else
	NumberOfUsers = Val(GetINI$("ListOfUsers", "NumberOfUsers", "0", IniFile$))
	If NumberOfUsers <> 0 Then
	ReDim ListOfUsers$(NumberOfUsers)
	ReDim ListOfPassphrases$(NumberOfUsers)
	For i = 1 To NumberOfUsers
	    ListOfUsers$(i) = GetINI$("ListOfUsers", "User#" & Str$(i), "NONE", IniFile$)
	    ListOfPassphrases$(i) = GetINI$("Passwords", ListOfUsers(i), "NONE", IniFile$)
	    frmPGPWinShell.cboUserName.AddItem ListOfUsers$(i)
	Next i
	frmPGPWinShell.cboUserName.ListIndex = 0
	End If
	NumberOfRecs = Val(GetINI$("ListOfRecs", "NumberOfRecs", "0", IniFile$))
	If NumberOfRecs <> 0 Then
	ReDim ListOfRecs$(NumberOfRecs)
	For i = 1 To NumberOfRecs
	    ListOfRecs$(i) = GetINI$("ListOfRecs", "REC#" & Str$(i), "NONE", IniFile$)
	    frmPGPWinShell.cboRecName.AddItem ListOfRecs$(i)
	Next i
	frmPGPWinShell.cboRecName.ListIndex = 0
	End If
End If
INISetup% = True
Exit Function
INIError:
    Resume INIExit
INIExit:
End Function

Sub MakeKey ()

toss% = Shell(PGPDir$ & "PGP1.PIF -kg +nomanual", 3)
While GetModuleUsage(toss%) > 0    ' Has Shelled program finished?
    DoEvents              ' If not, yield to Windows.
Wend

End Sub

Sub Process ()

If AskPassphrase = True Then Unload frmAskPassphrase

UserName = Chr$(34) & UserName & Chr$(34)
Passphrase = Chr$(34) & Passphrase & Chr$(34)
Recipient = Chr$(34) & Recipient & Chr$(34)

'Get an unused file handle
fha = FreeFile

CLIPCRYPT = False   'we don't want to erase the real files

If Filename$ <> "" Then
	If FileExists(Filename$) Then
		TempFile1$ = Filename$
	ElseIf FileExists(PGPDir$ + Filename$) Then
		TempFile1$ = PGPDir$ + Filename$
	Else
		MsgBox "PGP WinShell couldn't find the file! Be sure to enter the complete drive, path, and file name.", 16, "PGP Halted"
	Exit Sub
	End If
Else
	CLIPCRYPT = True
	If Clipboard.GetFormat(CF_TEXT) Then
	    Wipe = False
	    'Get a temporary filename
	    TempFile1$ = GetTempFile1()
	    'Open the file
	    Open TempFile1$ For Output As fha

	    Print #fha, Clipboard.GetText();

	    'We're done! Close the output file
	    Close fha
	Else
	    MsgBox "The clipboard does not contain text! To encrypt binary data, you must save it as a file and then encrypt it.", 16, "PGP Halted"
	GoTo Final
	    
	End If
End If

'set the default PIF to use
If KeepOpen = True Then
	'keep the inactive window open
	PGPPIF$ = "PGP2.PIF "
Else
	'close the inactive window
	PGPPIF$ = "PGP1.PIF "
End If

'determine what we're supposed to do
If CryptOpt = 0 Then
	Arg = "-sta"
	If Wipe = True Then Arg = Arg + "w"
	Recipient = ""
ElseIf CryptOpt = 1 Then
	Arg = "-es"
	If Wipe = True Then Arg = Arg + "w"
ElseIf CryptOpt = 2 Then
	Arg = ""
	Recipient = ""
	'the Decrypt File PIF leaves the window open after PGP is done
	'so you can see if the signature was good
	PGPPIF$ = "PGP2.PIF "
End If

toss% = Shell(PGPDir$ & PGPPIF$ & Arg & " " & TempFile1$ & " " & Recipient & " -z " & Passphrase$ & " -u " & UserName, 3)
	
	While GetModuleUsage(toss%) > 0    ' Has Shelled program finished?
	    DoEvents              ' If not, yield to Windows.
	Wend

If CLIPCRYPT = True Then
	'make the script wait until PGP is done working
	
	If Clipboard.GetFormat(CF_TEXT) Then
	'Get an unused file handle
	fhb = FreeFile

	'Open the signed file
	TempFile2$ = GetTempFile2()

	If Not FileExists(TempFile2$) Then
		'let the User know PGP had an error
		MsgBox "PGP Winshell encountered a problem. Make sure you have entered your User ID and Passphrase correctly.", 48, "PGP WinShell Halted"
		GoTo Sneeze
	End If

	Open TempFile2$ For Input As fhb

	ClipSign$ = Input$(LOF(fhb), #fhb)

	'We're done! Close the input file
	Close fhb

	'Put the altered file in the clipboard
	 Clipboard.SetText ClipSign$    ' Copy from Clipboard.

	'Now get rid of the file
	Kill TempFile2$
	
Sneeze: 'PGP sneezed while processing TempFile1

	Else
	MsgBox "Clipboard error. The clipboard's contents have been corrupted.", 48, "PGP WinShell"
	End If
	If FileExists(TempFile1$) Then Kill TempFile1$
End If

Final:  'This is the end, my only friend

End Sub

Function SetINI% (AppName$, KeyName$, SetName$, Filename$)
Dim DeleteIt As Long
Dim Result As Integer

DeleteIt = 0&
If SetName$ = "" Then       'Delete KeyName
    Result% = WritePrivateProfileString(AppName$, KeyName$, DeleteIt, Filename$)
ElseIf KeyName$ = "" Then   'delete section
    Result% = WritePrivateProfileString(AppName$, DeleteIt, "", Filename$)
Else
    Result% = WritePrivateProfileString(AppName$, KeyName$, SetName$, Filename$)
End If
SetINI% = Result%
End Function

Sub SetUpRecs ()
Dim FileNum, Result As Integer
Dim TempBatFile, TempKeyFile, TempBat, TextLine, IDLine As String

TempBatFile = PGPDir$ & "~prkeys.bat"
TempKeyFile = PGPDir$ & "~prkeys.txt"
FileNum = FreeFile
Open TempBatFile For Output As FileNum
TempBat = PGPDir$ & "PGP.EXE -kv pubring.pgp > " & TempKeyFile
Print #FileNum, TempBat;
Close #FileNum

toss% = Shell(PGPDir$ & "~PRKEYS.PIF", 7)

While GetModuleUsage(toss%) > 0    ' Has Shelled program finished?
    DoEvents              ' If not, yield to Windows.
Wend

FileNum = FreeFile
Open TempKeyFile For Input As FileNum
Looking:
Line Input #FileNum, TextLine
If TextLine = "" Then
    GoTo Looking
ElseIf TextLine = "Type bits/keyID    Date       User ID" Then
    GoTo Looking
Else
    If Len(TextLine) < 31 Then
	NumberOfUsers = 0
	GoTo DoneFilling
    End If
End If
i = 0
frmPGPWinShell.cboRecName.Clear
IDLine = "NONE"
Result = SetINI("ListOfRecs", "NumberOfRecs", "0", IniFile$)
FillBox:
    IDLine = Right$(TextLine, (Len(TextLine) - 30))
    frmPGPWinShell.cboRecName.AddItem IDLine
    i = i + 1
    ReDim Preserve ListOfRecs(i)
    ListOfRecs(i) = IDLine
    Result = SetINI("ListOfRecs", "REC#" & Str$(i), ListOfRecs(i), IniFile$)
    Line Input #FileNum, TextLine
    If Len(TextLine) < 31 Then GoTo DoneFilling
GoTo FillBox

DoneFilling:
NumberOfRecs = i
Result = SetINI("ListOfRecs", "NumberOfRecs", Str$(i), IniFile$)
Close #FileNum

NumberOfRecs = i
If NumberOfRecs <> 0 Then frmPGPWinShell.cboRecName.ListIndex = 0

Kill TempBatFile
Kill TempKeyFile

End Sub

Sub SetUpUsers ()
Dim FileNum, Result As Integer
Dim Default, TempBatFile, TempKeyFile, TempBat, TextLine, IDLine As String

TempBatFile = PGPDir$ & "~prkeys.bat"
TempKeyFile = PGPDir$ & "~prkeys.txt"
FileNum = FreeFile
Open TempBatFile For Output As FileNum
TempBat = PGPDir$ & "PGP.EXE -kv secring.pgp > " & TempKeyFile
Print #FileNum, TempBat;
Close #FileNum

toss% = Shell(PGPDir$ & "~PRKEYS.PIF", 7)

While GetModuleUsage(toss%) > 0    ' Has Shelled program finished?
    DoEvents              ' If not, yield to Windows.
Wend

FileNum = FreeFile
Open TempKeyFile For Input As FileNum
Looking1:
Line Input #FileNum, TextLine
If TextLine = "" Then
    GoTo Looking1
ElseIf TextLine = "Type bits/keyID    Date       User ID" Then
    GoTo Looking1
Else
    If Len(TextLine) < 31 Then
	NumberOfUsers = 0
	GoTo DoneFilling1
    End If
End If
i = 0
frmPGPWinShell.cboUserName.Clear
IDLine = "NONE"
Result = SetINI("ListOfUsers", "NumberOfUsers", "0", IniFile$)
FillBox1:
    IDLine = Right$(TextLine, (Len(TextLine) - 30))
    frmPGPWinShell.cboUserName.AddItem IDLine
    i = i + 1
    ReDim Preserve ListOfUsers(i)
    ListOfUsers(i) = IDLine
    Result = SetINI("ListOfUsers", "User#" & Str$(i), ListOfUsers(i), IniFile$)
    ReDim Preserve ListOfPassphrases$(i)
    ListOfPassphrases$(i) = GetINI$("Passwords", ListOfUsers(i), "NONE", IniFile$)
    Line Input #FileNum, TextLine
    If Len(TextLine) < 31 Then GoTo DoneFilling1
GoTo FillBox1

DoneFilling1:
NumberOfUsers = i
Result = SetINI("ListOfUsers", "NumberOfUsers", Str$(i), IniFile$)
Close #FileNum

If NumberOfUsers <> 0 Then frmPGPWinShell.cboUserName.ListIndex = 0

Kill TempBatFile
Kill TempKeyFile

ListOfUsers$(0) = "NONE"
ListOfPassphrases$(0) = "NONE"

End Sub

